#include <bits/stdc++.h>

using namespace std;

int h, w;
vector<uint64_t> sums_strs, sums_cols;
vector<vector<int>> v;
uint64_t sum_all = 0;
int count_opers = 0;

void del_str(int str)
{
    for (int i = 0; i < w; i++)
        sums_cols[i] -= v[str][i];
    sum_all -= sums_strs[str];
    sums_strs[str] = 0;
}

void del_col(int col)
{
    for (int i = 0; i < h; i++)
        sums_strs[i] -= v[i][col];
    sum_all -= sums_cols[col];
    sums_cols[col] = 0;
}

void test(int hor, int ver)
{
    for (int horcheck = 0; horcheck < h; horcheck++)
    {
        if (1 << horcheck & hor) {
            del_str(h - horcheck - 1);
            count_opers++;}
    }

    for (int vercheck = 0; vercheck < w; vercheck++)
    {
        if (1 << vercheck & ver) {
            del_col(w - vercheck - 1);
            count_opers++;}
    }
}

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cin >> h >> w;
    v.resize(h, vector<int>(w));
    sums_strs.reserve(h);
    sums_cols.resize(w);
    for (auto &hh : v)
    {
        uint64_t sum_str = 0;
        for (int i = 0; i < w; i++)
        {
            cin >> hh[i];
            sums_cols[i] += hh[i];
            sum_str += hh[i];
        }
        sums_strs.push_back(sum_str);
        sum_all += sum_str;
    }
    auto orig_sums_strs = sums_strs;
    auto orig_sums_cols = sums_cols;
    auto orig_sum_all = sum_all;
    uint64_t sm;
    cin >> sm;
    if (sum_all < sm)
    {
        cout << "NO";
        return 0;
    }
    for (int hor = 0; hor < pow(2, w); hor++)
    {
        for (int ver = 0; ver < pow(2, h); ver++)
        {count_opers = 0;
            test(hor, ver);
            if (sum_all == sm)
            {
                cout << "YES\n" << count_opers << "\n";
                for (int horcheck = 0; horcheck < h; horcheck++)
                    if (1 << horcheck & hor)
                        cout << 1 << " " << h - horcheck << '\n';
                for (int vercheck = 0; vercheck < w; vercheck++)
                    if (1 << vercheck & ver)
                        cout << 2 << " " << w - vercheck << '\n';
                return 0;
            }
            else
            {
                sums_strs = orig_sums_strs;
                sums_cols = orig_sums_cols;
                sum_all = orig_sum_all;
            }
        }
    }
    cout << "NO";
}